// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::prelude::*;
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlGraphRenderer")]
    pub struct GraphRenderer(Interface<ffi::DzlGraphRenderer, ffi::DzlGraphRendererInterface>);

    match fn {
        type_ => || ffi::dzl_graph_view_renderer_get_type(),
    }
}

impl GraphRenderer {
    pub const NONE: Option<&'static GraphRenderer> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::GraphRenderer>> Sealed for T {}
}

pub trait GraphRendererExt: IsA<GraphRenderer> + sealed::Sealed + 'static {
    //#[doc(alias = "dzl_graph_view_renderer_render")]
    //fn render(&self, table: &impl IsA<GraphModel>, x_begin: i64, x_end: i64, y_begin: f64, y_end: f64, cr: /*Ignored*/&mut cairo::Context, area: &cairo::RectangleInt) {
    //    unsafe { TODO: call ffi:dzl_graph_view_renderer_render() }
    //}
}

impl<O: IsA<GraphRenderer>> GraphRendererExt for O {}

impl fmt::Display for GraphRenderer {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("GraphRenderer")
    }
}
